#include <avr/interrupt.h>
#include "uart3.h"

#include "../common/bascom_typy.h"

//zmienne bufora nadawczego uartu
volatile char UART_TxBuf[UART_TX_BUF_SIZE];
volatile byte UART_TxHead=0;
volatile byte UART_TxTail=0;


void PrintBuf(char tekst[]){
	byte pom=0;
	while(tekst[pom++]) {
		PrintbinBuf (tekst[pom-1]);
	} 


}

void  Printbin (unsigned char data) {
	while ( !( UCSRA & (1<< UDRE)));
	UDR=data;
}

//funkcja na podstawie ksiazki "Mikrokontrolery AVR, jezyk C, podstawy programowania." M. Karadas
void  PrintbinBuf (unsigned char data) {
	byte tmp_head;
	
	tmp_head=(UART_TxHead +1) & UART_TX_BUF_MASK;
	//czekanie, jesli caly bufor jest zapelniony
	while ( tmp_head == UART_TxTail ) {}
	
	UART_TxBuf[tmp_head] = data;
	UART_TxHead = tmp_head;

	//inicjalizacja przerwania wystepujacego, gdy bufor nadawczy sprzetowego UART'u jest pusty
	UCSRB |= (1<<UDRIE);

}

//funkcja na podstawie ksiazki "Mikrokontrolery AVR, jezyk C, podstawy programowania." M. Karadas
ISR( USART_UDRE_vect) {
	
	//sprawdzamy czy indeksy sa rozne
	if (UART_TxHead != UART_TxTail) {
		//obliczamy i zapamietujemy nowy indeks konca bufora
		UART_TxTail = (UART_TxTail + 1) & UART_TX_BUF_MASK;
		//wrzucamy bajt z bufora do bufora sprzetowego UART'u
		UDR=UART_TxBuf[UART_TxTail];
	}
	else {
		//jesli bufor jest pusty to zerowanie flagi przerwania
		UCSRB &= ~(1<<UDRIE);
	}
	
}

//funkcja na podstawie ksiazki "Mikrokontrolery AVR, jezyk C, podstawy programowania." M. Karadas
void USART_Init( uint16_t baud ) {
	/* Ustawienie prdkoci */
	UBRRH = (uint8_t)(baud>>8);
	UBRRL = (uint8_t)baud;
	/* Ustawienie format ramki: 8bitw danych, 1 bit stopu */
	UCSRC = (1<<URSEL)|(3<<UCSZ0);

	/* Zaczenie nadajnika I odbiornika */
	UCSRB |= (1<<RXEN)|(1<<TXEN); 
	
}
