#include	<inttypes.h>
#include 	<avr/io.h>
#include 	<avr/iom8.h>

#include "../common/bascom_typy.h"
#include "wysw3cy1sw.h"

#ifndef opoznienie_klawisza
	#define opoznienie_klawisza 4 //mniej = szybciej mozna wciskac 
#endif

struct {
	uint8_t led1:1;
	uint8_t led2:1;
	uint8_t led3:1;
	uint8_t migajled3:1;
	uint8_t migajwysw:1;
	uint8_t sw:1;
} bityA;



volatile byte wyswb0;
volatile byte wyswb1;
volatile byte wyswb2;
volatile byte etimer4;


//funkcja ogarniajaca wyswietlacz
//ustawia tez flage klawiatury (zajmuje sie odczytem klawisza)
//wspolna anoda + 3 dodatkowe ledy wpiete przeciwsobnie (katody do anody 3) oraz klawisz
void odwysw (void){
	byte pom1=0;
	static byte licznikwysw;
	static byte licznikkla;
	static byte wyswrot;
	static byte sw1=opoznienie_klawisza;

	 	//odpowiednik rotate
	 	wyswrot=~wyswrot;
		wyswrot= (wyswrot >> 1);
	 	if (!wyswrot) wyswrot=128;
		wyswrot=~wyswrot;	

	licznikwysw++;
	if (licznikwysw >54) {
		licznikwysw=52;

	 }
	licznikkla++;
	
	//if ((licznikkla<<7)) licznikkla=0;
	if (licznikkla==128) licznikkla=0;
	
	LedOffAnody; //wylaczenie wszystkich anod
	
	
	//miganie led 3
	if (licznikkla==96 && bityA.migajled3)  {
		if ( etimer4 & 0b00001000 ) bityA.led3 =0 ; else bityA.led3 = 1;
	}
	//led 3
	if (licznikkla==96 && bityA.led3) {
		LedOnDDRA3;  //wlaczenie jak wyjscie (stan niski na sw i katodach ledow) 
		DDRB = 0b00100000; //jako wejscie nieuzywane katody z B
		PORTB = (1<<PB5);
	}
	//led 2
	else if (licznikkla==64 && bityA.led2) {
		LedOnDDRA3;  //wlaczenie jak wyjscie (stan niski na sw i katodach ledow) 
		DDRB = 0x01;
		PORTB = (1<<PB0);
	}
	//led1
	else if (licznikkla==32 && bityA.led1) {
		LedOnDDRA3;  //wlaczenie jak wyjscie (stan niski na sw i katodach ledow) 
		DDRD |= 0b10000000;  //jako wyjscie anoda led 1
		DDRB = 0x00; //jako wejscie nieuzywane katody z B
		PORTD |= (1<<PD7); //anoda led 1   = 1
	}
	//odczyt klawisza
	else if (!licznikkla) {
		PORTD |= (1<<PD6); //ustawienie 1 na PD6 (biegun SW polaczony z katoda DP)
		DDRB = 0xFF;
		//DDRD &= ~(1<<PD6);  //ustawienie jako wejscie PD6
		LedOffDDRAnody; //wlaczenie wejsc na anodach 
		DDRD |= (1<<PD4); //wlaczenie jako wyjscie PD4 (anoda 3 i wspolne led 123 oraz sw)
		PORTD &= ~(1<<PD4); //ustawienie 0 na drugim biegunie uSW (anoda 3 i wspolne led 123 oraz sw)
		//jesli klawisz wcisniety
		if (!(PIND & (1<<PD6))) {
			if (sw1==opoznienie_klawisza) bityA.sw=1;
			sw1=0;

		}
		else {
			//zmienna anty-drganiowa
			if (sw1 != opoznienie_klawisza) sw1++;
		}
		
	}
	
	//odswiezanie wyswietlacza
	else
	{
		LedOffDDRAnody; //wlaczenie stanu wysokiej impedancji na anodach
		PORTB=0;
		PORTD &= 0b00111111;
		DDRB=0; //wlaczenie stanu wysokiej imp na portach katod
		DDRD &= 0b00111111; //wlaczenie stanu wysokiej imp na portach anod
		switch (licznikwysw)
			{
				case 52:
					pom1 = wyswb2 | wyswrot;
					LedOnA1;
					LedOnDDRA1;
				break;
				case 53:
					pom1 = wyswb1 | wyswrot;
					LedOnA2;
					LedOnDDRA2;
				break;
				case 54:
					pom1 = wyswb0 | wyswrot;
					LedOnA3;
					LedOnDDRA3;
				break;
			}
		if ( (etimer4 & 0b00001000)  && bityA.migajwysw) pom1=0xFF;
		DDRB= ~pom1;
		DDRD &= 0b00111111;
		DDRD |= (0b11000000 & ~pom1);
	}
	//PD6 - sw
	//PB5 led3
	//PB2 led2
	//PD7 led1

}

